<?xml version="1.0" encoding="utf-8"?>

<!--
Chrysalis Web Framework [http://chrysalis.sourceforge.net]
Copyright (c) 2002, 2003, 2004, Paul Strack

All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice,
this list of conditions and the following disclaimer in the documentation
and/or other materials provided with the distribution.

3. Neither the name of the copyright holder nor the names of its contributors
may be used to endorse or promote products derived from this software without
specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:output method="html"/>

  <xsl:template match="web-app">
    <html>
      <head>
        <title><xsl:value-of select="display-name"/> Web Application Documentation</title>
      </head>

      <body>
        <h1><code><xsl:value-of select="display-name"/></code> Web Application Documentation</h1>
		
        <p><xsl:value-of select="description"/></p>
		
        <h3>Servlets</h3>
		
        <ul>
          <xsl:apply-templates select="servlet" mode="toc">
	    <xsl:sort select="display-name"/> 
          </xsl:apply-templates>
        </ul>
		
        <h3>Web Application Description</h3>
		
        <p><xsl:apply-templates select="comment()"/></p>	
		
        <xsl:apply-templates select="servlet"/>
      </body>
  
     </html>
  </xsl:template>

  <xsl:template match="servlet" mode="toc">
    <xsl:if test="servlet-class">
      <li>
        <xsl:element name="a">
          <xsl:attribute name="href">#<xsl:value-of select="servlet-name"/></xsl:attribute>
          <code><xsl:value-of select="display-name"/></code>
        </xsl:element>:
        <xsl:value-of select = "description"/>.
      </li>
    </xsl:if>
  </xsl:template>

  <xsl:template match="servlet">
    <xsl:if test="servlet-class">
      <hr/>
      <h2>
        <xsl:element name="a">
          <xsl:attribute name="name"><xsl:value-of select="servlet-name"/></xsl:attribute>
        </xsl:element>
        <code><xsl:value-of select="display-name"/></code> Servlet
      </h2>
	
      <p>
      <b>Servlet Class</b>: <code><xsl:value-of select="servlet-class"/></code><br/>
      <xsl:variable name="servletName" select="servlet-name"/>
      <xsl:for-each select="//web-app/servlet-mapping">
        <xsl:if test="servlet-name=$servletName">
          <b>URL Pattern</b>: <code><xsl:value-of select="url-pattern"/></code><br/>
        </xsl:if>
      </xsl:for-each>
      </p>
    
      <p><xsl:apply-templates select="comment()"/></p>
    </xsl:if>
  </xsl:template>

  <xsl:template match = "comment()"> 
    <xsl:value-of select = "." disable-output-escaping="yes"/>
  </xsl:template>
</xsl:stylesheet>
